#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>

#include "MMBEBHE.h"

#ifndef L
#define L 256
#endif

MMBEBHE::MMBEBHE(char *file,int bEHE) : Equalization(file,bEHE,AL_MMBEBHE)
{
}

void MMBEBHE::Equalizing()
{
	double mean,meanV[L];
	register int l,k,lmax;

	/* Mean calculation */
	mean = 0.;
	for ( l = 0 ; l < L ; l++ )
		mean += l * m_pH[l];
	mean /= m_iPixels;

	/* Mean calculation */
	for ( l = 0 ; l < L-1 ; l++ )
	{
		HistEq(0,l);
		HistEq(l+1,L-1);

		meanV[l] = 0.;
		for ( k = 0 ; k < L ; k++ )
			meanV[l] += m_pNL[k] * m_pH[k];
		meanV[l] /= m_iPixels;
//		fprintf(stdout,"meanV[%d] = %lf\n",l,meanV[l]);
	}

	for ( lmax = 0, l = 1; l < L-1 ; l++ )
	{
		if ( ( fabs(mean - meanV[lmax]) > fabs(mean - meanV[l]) ) )
			lmax = l;
	}
//	fprintf(stdout,"lmax = %d\n",lmax);

	HistEq(0,lmax);
	HistEq(lmax+1,L-1);

	Equalization::Equalizing();
}

const char* MMBEBHE::GetAlgorithm()
{
	return "MMBEBHE";
}
