#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>

#include "MMBEMHE.h"

#ifndef L
#define L 256
#endif

MMBEMHE::MMBEMHE(char *file,int bEHE,int _r) : Equalization(file,bEHE,AL_MMBEMHE)
{
	m_r = _r;
}

double*** aloc(int X, int Y, int Z)
{
	register int i,j;
	double*** W;

	W = new double**[X];

	W[0] = new double*[X*Y];
	for ( i = 1 ; i < X ; i++ )
		W[i] = W[0] + i * Y;

	W[0][0] = new double[X*Y*Z];
	for ( i = 0 ; i < X ; i++ )
		for ( j = 0 ; j < Y ; j++ )
			W[i][j] = W[0][0] + j * Z + i * Y * Z;

	return W;
}

void delet(double*** W)
{
	delete  W[0][0];
	delete  W[0];
	delete  W;
}

void MMBEMHE::Equalizing()
{
	double mean;
	double ***meanV;
	register int l,m,n,k;
	int lmax,mmax,nmax;

	meanV = aloc(L,L,L);

	/* Mean calculation */
	mean = 0.;
	for ( k = 0 ; k < L ; k++ )
		mean += k * m_pH[k];
	mean /= m_iPixels;

	/* Mean calculation */
	for ( l = 0 ; l < L-1 ; l++ )
	{
		for ( m = l+1 ; m < L-1 ; m++ )
		{
			for ( n = m+1 ; n < L-1 ; n++ )
			{
				HistEq(0,l);
				HistEq(l+1,m);
				HistEq(m+1,n);
				HistEq(n+1,L-1);

				meanV[l][m][n] = 0.;
				for ( k = 0 ; k < L ; k++ )
					meanV[l][m][n] += m_pNL[k] * m_pH[k];
				meanV[l][m][n] /= m_iPixels;
			}
		}
	}

	for ( lmax = 0, mmax = 1, nmax = 0, l = 0 ; l < L-1 ; l++ )
		for ( m = l+1; m < L-1 ; m++ )
			for ( n = m+1 ; n < L-1 ; n++ )
			{
				if ( ( fabs(mean - meanV[lmax][mmax][nmax]) > fabs(mean - meanV[l][m][n]) ) )
				{
					lmax = l;
					mmax = m;
					nmax = n;
				}
			}
	fprintf(stdout,"mmax = %d, lmax = %d\n",mmax,lmax);

	HistEq(0,lmax);
	HistEq(lmax+1,mmax);
	HistEq(mmax+1,nmax);
	HistEq(nmax+1,L-1);

	Equalization::Equalizing();

	delet(meanV);
}

const char* MMBEMHE::GetAlgorithm()
{
	static char sTmp[BUFSIZ];
	sprintf(sTmp,"MMBEMHE%1d",m_r);
	return sTmp;
}
