#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>

#include "RMSHE.h"

#ifndef L
#define L 256
#endif

RMSHE::RMSHE(char *file,int bEHE,int _r) : Equalization(file,bEHE,AL_RMSHE)
{
	m_r = _r;
}

void RMSHE::Equalizing()
{
	EqualizingRecursive(0,L-1,0);

	Equalization::Equalizing();
}


void RMSHE::EqualizingRecursive(int low, int high,int level)
{
	double mean;
	register int l;

	if (level == m_r)
		HistEq(low        ,high     );
	else
	{
		/* Mean calculation */
		mean = 0.;
		for ( l = low ; l <= high ; l++ )
			mean += l * m_pH[l];
		mean /= m_iPixels;

		EqualizingRecursive(low        ,(int)mean,level+1);
		EqualizingRecursive((int)mean+1,high     ,level+1);
	}
}

const char* RMSHE::GetAlgorithm()
{
	static char sTmp[BUFSIZ];
	sprintf(sTmp,"RMSHE%1d",m_r);
	return sTmp;
}
