#ifndef _DEFS_H_

#include <stdlib.h>

/* #define NULL  0 */

#define FALSE 0
#define TRUE  1

typedef void*          PVOID;

typedef       char*    PSTR;
typedef const char*    PCTSTR;

typedef unsigned char  BYTE;
typedef unsigned int   UINT;
typedef unsigned int   DWORD;
typedef unsigned short WORD;
typedef int            BOOL;
typedef int            LONG; /* long, modification to work in 64 bits computers */
typedef int            POSITION;

typedef DWORD          COLORREF;

#define ASSERT(p)\
	if ((p) == FALSE)\
		exit(1);
#define ASSERT_VALID(p)\
	if ((p) == NULL)\
		exit(1);

#define max(x,y)   ((x)>(y)?(x):(y))
#define max3(x,y,z) (max(max(x,y),z))

#define min(x,y)   ((x)<(y)?(x):(y))
#define min3(x,y,z) (min(min(x,y),z))

#define RGB(r,g,b)          ((COLORREF)(((BYTE)(r)|((WORD)((BYTE)(g))<<8))|(((DWORD)(BYTE)(b))<<16)))

#define GetRValue(rgb)   ((BYTE) (rgb))
#define GetGValue(rgb)   ((BYTE) (((WORD) (rgb)) >> 8))
#define GetBValue(rgb)   ((BYTE) ((rgb) >> 16))

#endif

