#ifndef DIB
	#define DIB
	#include "DIB.h"
#endif

#ifndef _EQUALIZATION_H_
#define _EQUALIZATION_H_

typedef enum type_algorithm {AL_NONE,AL_HE,AL_BBHE,AL_DSIHE,AL_MMBEBHE,AL_MMBEMHE,AL_BPHEME,AL_RMSHE} TypeAlgorithm;
typedef enum type_program   {PRG_NONE,PRG_CLASSIC,PRG_CUBIC_INCREMENTAL,PRG_CUBIC_PROPORTIONAL,PRG_ITERATIVE_INCREMENTAL,PRG_ITERATIVE_PROPORTIONAL,PRG_ITERATIVE_ONE} TypeProgram;

class CPoint
{
public:
	int x,y;

	CPoint(int _x,int _y)
	{	
		x = _x; 
		y = _y;
	}
};

class Equalization
{

protected:
	int   m_iPixels;
	int   m_iWidth;
	int   m_iHeight;
	CDIB *m_pImgOut;
	CDIB *m_pImgIn;

protected:
	char          m_sFileName[BUFSIZ];		
	int           m_bEHE;
	TypeAlgorithm m_tpAlgorithm;
	TypeProgram   m_tpProgram;
	
	int     *m_pH;

	int     *m_pLList;
	int     *m_pPLList;
	CPoint  *m_pPtList;

	int     *m_pPPL;

	double  *m_pC;
	int     *m_pNL;
	
public:	
	// Construtoras
	Equalization(char * arquivo,int bEHE,TypeAlgorithm);
	virtual ~Equalization();

	void InitData(void);
	void ClearData(void);

	void ConstructHist(void);

	void  SetAlgorithm (TypeAlgorithm);

	virtual const char* GetAlgorithm (void)=0;

	char* GetHistogramEqualizationType(void);

	void Saving();

	virtual void Equalizing()=0;
	void HistEq(int low,int high);

};
#endif // _EQUALIZATION_H_
