#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "DIB.h"

#define L 256
#define LOG2(x) (log(x) / log(2.))

int main(int argc,char** argv)
{
	int H[L];
	double P[L];
	register int i,j,l;
	int N;
	double mean,entropy;

	if (argc < 2)
	{
		fprintf(stderr,"use %s [file.jpg ou bmp]\n",argv[0]);
		exit(1);
	}

	// Define objeto para imagem
	CDIB A;

	if (!A.AbrirArquivo(argv[1]))
	{
		fprintf(stderr,"error while opening first file!\n");
		exit(2);
	}

	N = A.GetImageHeight() * A.GetImageWidth();

	memset(H,0,L*sizeof(int));

	for(i=0;i<(int)A.GetImageHeight();i++)
		for(j=0;j<(int)A.GetImageWidth();j++)
			H[A.GetPixelG8(j, i)]++;

	mean=0.;
	for(l=0;l<L;l++)
	{
		mean += l * H[l];
		P[l] = (double)H[l] / N;
	}
	mean /= N;

	entropy = 0.;
	for(l=0;l<L;l++)
	{
		if (H[l] > 0)
			entropy += -P[l] * LOG2(P[l]);
//		fprintf(stdout,"%3d - %8.6lf %5d %8.6lf %8.6lf\n",l,P[l],H[l],entropy,LOG2(P[l]));
	}
	fprintf(stdout,"\n");
	fprintf(stdout,"mean brightness  = %lf\n",mean);
	fprintf(stdout,"discrete entropy = %lf\n",entropy);
	return 0;
}

