#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "DIB.h"

int main(int argc,char** argv)
{
	
	if (argc < 3) 
	{
		fprintf(stderr,"use %s [file.jpg ou bmp] [file2.jpg ou bmp]\n",argv[0]);
		exit(1);
	}

	// Define objeto para imagem
	CDIB A,B,C;

	if (!A.AbrirArquivo(argv[1]))
	{
		fprintf(stderr,"error while opening first file!\n");
		exit(2);
	}

	if (!B.AbrirArquivo(argv[2]))
	{
		fprintf(stderr,"error while opening second file!\n");
		exit(2);
	}

	if (!C.AbrirArquivo(argv[3]))
	{
		fprintf(stderr,"error while opening thirde file!\n");
		exit(2);
	}

	if ( (A.GetImageHeight() != B.GetImageHeight() ) || 
	     (A.GetImageWidth()  != B.GetImageWidth()  ) )
	{
		fprintf(stdout,"image dimensions are diferents\n(%dx%d) e (%dx%d)\n"
		 ,A.GetImageWidth()
		 ,A.GetImageHeight()
		 ,B.GetImageWidth()
		 ,B.GetImageHeight());
		exit(3);
	}

	int ct=0;
	double mse = 0., mseR = 0., mseG = 0., mseB = 0.;
	int i,j;

	int rA, gA, bA;
	int rB, gB, bB;
	int rC, gC, bC;
	for(i=0;i<(int)A.GetImageHeight();i++)
	{
		for(j=0;j<(int)A.GetImageWidth();j++)
		{
			
			rA = A.GetPixelTCR(j, i);
			gA = A.GetPixelTCG(j, i);
			bA = A.GetPixelTCB(j, i);
	
			rB = B.GetPixelTCR(j, i);
			gB = B.GetPixelTCG(j, i);
			bB = B.GetPixelTCB(j, i);

			rC = C.GetPixelTCB(j, i);
			gC = C.GetPixelTCG(j, i);
			bC = C.GetPixelTCB(j, i); 

			mse += 
			  (double)(rA - rB) * (rA - rB)
			+ (double)(gA - gB) * (gA - gB)
			+ (double)(bA - bB) * (bA - bB);
			mseR += (double)(rA - rB) * (rA - rB);
			mseG += (double)(gA - gB) * (gA - gB);
			mseB += (double)(bA - bB) * (bA - bB);

			if (rA != rB || gA != gB || bA != bB )
			{
//				fprintf(stdout,"(%d,%d,%d) (%d,%d,%d)\n",rA,gA,bA,rB,gB,bB);
				ct++;
			}	
/*
			if ( conta != 0 )
			{
				fprintf(stdout,"in: (%3d,%3d,%3d), (%3d,%3d,%3d) - (%3d,%3d,%3d)\n",rC,gC,bC,rA,gA,bA,rB,gB,bB);
				exit(0);
			}
*/
		}
	}
	mse  /= (double)3.*A.GetImageHeight()*A.GetImageWidth();
	mseR /= (double)   A.GetImageHeight()*A.GetImageWidth();
	mseG /= (double)   A.GetImageHeight()*A.GetImageWidth();
	mseB /= (double)   A.GetImageHeight()*A.GetImageWidth();
	mse   = sqrt(mse);
	mseR  = sqrt(mseR);
	mseG  = sqrt(mseG);
	mseB  = sqrt(mseB);
	fprintf(stdout,"o mse = %lf, mseR = %lf, mseG = %lf, mseB = %lf\n", mse, mseR, mseG, mseB);
	fprintf(stdout,"different pixels: %d\n",ct);
	return 0;
}

