#ifndef _PALETTE_H_
#define _PALETTE_H_

#include "defs.h"

#ifndef PALVERSION
#define PALVERSION 0x300;
#endif

/* palette entry flags */
#define PC_RESERVED     0x01    /* palette index used for animation */
#define PC_EXPLICIT     0x02    /* palette index is explicit to device */
#define PC_NOCOLLAPSE   0x04    /* do not match color to system palette */


//#pragma pack(1)
typedef struct tagPALETTEENTRY {
    BYTE        peBlue;
    BYTE        peGreen;
    BYTE        peRed;
    BYTE        peFlags;
} PALETTEENTRY, *PPALETTEENTRY;

//#pragma pack(1)
/* Logical Palette */
typedef struct tagLOGPALETTE {
    WORD         palVersion;
    WORD         palNumEntries;
    PALETTEENTRY palPalEntry[1];
} LOGPALETTE, *PLOGPALETTE;

class CPalette
{
public:
// Constructors
	CPalette();
	~CPalette();
	BOOL CreatePalette(PLOGPALETTE pLogPalette);

//  Primitivas
	PLOGPALETTE		m_pPalette;

// Attributes
	int		GetEntryCount();
	BOOL	GetPaletteEntry(UINT nIndex, PALETTEENTRY& PaletteColor) const;
	BOOL	SetPaletteEntry(UINT nIndex, PALETTEENTRY PaletteColor);

// Operations
	int		GetNearestPaletteIndex(COLORREF crColor) const;
	BOOL	ResizePalette(UINT nNumEntries);
private:
	void 	DestroyPalette();
};
#endif

