#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#define JMAX 300

double rtnewt( void (*funcd)(double,double,double*,double*),double x1,double x2,double xacc,double mu)
{
	int j;
	double f,df,dx,rtn;

	rtn = 0.5*(x1+x2); /* initial guess */
	for(j=1;j<=JMAX;j++)
	{
		(*funcd)(rtn,mu,&f,&df);
		dx = f/df;
		rtn -= dx;
		if ( (x1-rtn)*(rtn-x2) < 0. ) { fprintf(stderr,"Jumped out of brackets in rtnewt (%lf)\n",rtn); exit(1); }
		if ( fabs(dx) < xacc ){ fprintf(stdout,"iter = %d\n",j); return rtn;}
	}
	fprintf(stderr,"Maximum number of iterions exceeded in rtnewt\n");
	return rtn;
}

void flambda2(double x,double mu,double *f, double *df)
{
	*f  = ( 1. - mu ) * x * exp ( x ) - exp(x) + 1. + mu * x ;
	*df = ( 1. - mu ) * ( exp ( x ) + x * exp ( x ) ) - exp ( x ) + mu;
}

int main(void)
{
	double x=0.,mean;

	mean = 0.6;
	if (mean	== 0.5)
		x = 0.;
	if ( mean > 0.5 )
		x = rtnewt(flambda2,   0.,200.,0.001,mean);
	else
		x = rtnewt(flambda2,-200.,  0.,0.001,mean);

	fprintf(stdout,"root = %lf\n",x);

	return 0;
}
